"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function(o, m, k, k2) {
    void 0 === k2 && (k2 = k);
    var desc = Object.getOwnPropertyDescriptor(m, k);
    desc && !("get" in desc ? !m.__esModule : desc.writable || desc.configurable) || (desc = {
        enumerable: !0,
        get: function() {
            return m[k];
        }
    }), Object.defineProperty(o, k2, desc);
} : function(o, m, k, k2) {
    void 0 === k2 && (k2 = k), o[k2] = m[k];
}), __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function(o, v) {
    Object.defineProperty(o, "default", {
        enumerable: !0,
        value: v
    });
} : function(o, v) {
    o.default = v;
}), __importStar = this && this.__importStar || function(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (null != mod) for (var k in mod) "default" !== k && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
    return __setModuleDefault(result, mod), result;
}, __importDefault = this && this.__importDefault || function(mod) {
    return mod && mod.__esModule ? mod : {
        default: mod
    };
};

Object.defineProperty(exports, "__esModule", {
    value: !0
});

const WebAssemblyRunner_1 = __importDefault(require("@libmedia/cheap/webassembly/WebAssemblyRunner")), logger = __importStar(require("@libmedia/common/util/logger"));

exports.default = class {
    resampler;
    options;
    inputParameters;
    outputParameters;
    constructor(options) {
        this.options = options, this.resampler = new WebAssemblyRunner_1.default(this.options.resource);
    }
    async open(input, output) {
        this.inputParameters = input, this.outputParameters = output, await this.resampler.run(), 
        this.resampler.call("resample_set_input_parameters", input.sampleRate, input.channels, input.format, input.layout || 0), 
        this.resampler.call("resample_set_output_parameters", output.sampleRate, output.channels, output.format, output.layout || 0);
        let ret = this.resampler.call("resample_init");
        ret < 0 && logger.fatal(`open resampler failed, ret: ${ret}`, "src/audioresample/Resampler.ts", 84);
    }
    resample(input, output, numberOfFrames) {
        return this.resampler.call("resample_process", input, output, numberOfFrames);
    }
    getOutputSampleCount(numberOfFrames) {
        return this.resampler.call("resample_nb_sample", numberOfFrames);
    }
    close() {
        this.resampler.call("resample_destroy"), this.resampler.destroy(), this.resampler = null;
    }
    getInputPCMParameters() {
        return this.inputParameters;
    }
    getOutputPCMParameters() {
        return this.outputParameters;
    }
};
//# sourceMappingURL=Resampler.js.map